<?php

// custom navigation links
function mollio_nav($parent, $items = array(), $main_class = '') {
  $i = 0;
  $class = '';
  $wrapper_prefix = '<li>';
  $wrapper_suffix = '</li>';
  $output = '';

  if (count($items) > 0) {
    $output .= "<ul>";
    foreach ($items as $item) {
      $class = '';
      if ($i == 0) {
        $class = 'first';
      }
      elseif ($i == count($items) - 1) {
        $class = 'last';
      }

      if (strstr($item, 'class="active"') !== FALSE) {
        $class .= ($class?' ':'') . 'active';
        $main_class .= ($main_class != '' ? ' ' : '') . 'active';
        $parent = str_replace('<a href=', '<a class="active" href=', $parent);
      }

      $class = ' class="' . $class . '"';
      $output .= '<li' . $class . '>' . $item . '</li>';
      $i++;
    }
    $output .= "</ul>";
  }

  /*
  $path = 'href="' . $_GET['q'] . '"';
  if ($path == '') {
    $path = '/';
  }
  if (strstr($parent, $path) !== NULL) {
    $main_class .= ($main_class != '' ? ' ' : '') . 'active';
  }
  */

  $wrapper_prefix = '<li class="' . $main_class . '">';
  $output = $wrapper_prefix . $parent . $output . $wrapper_postfix;
  return $output;
}

// custom implementation of theme_list
function mollio_list($items, $type = 'ul') {
  $i = 0;
  $class = '';
  $output = '';
  $type = strtolower($type);
  if ($type != 'ol' && $type != 'dl') {
    $type = 'ul';
  }
  $output .= "<$type>";
  foreach ($items as $item) {
    $class = '';
    if ($i == 0) {
      $class = 'first';
    }
    elseif ($i == count($items) - 1) {
      $class = 'last';
    }

    if (strstr($item, 'class="active"') !== FALSE) {
      $class .= ($class?' ':'') . 'active';
    }

    $class = ' class="' . $class . '"';
    $output .= '<li' . $class . '>' . $item . '</li>';
    $i++;
  }
  $output .= "</$type>";
  return $output;
}

// custom breadcrumbs
function mollio_breadcrumb($breadcrumb) {
  $sep = ' / ';
  if (count($breadcrumb) > 0) {
    return implode($breadcrumb, $sep) . $sep;
  }
  else {
    return t("Home");
  }
}

// custom menu output
// menu_in_active_trail($mid)
function mollio_menu_tree($pid = 1) {
  if ($tree = menu_tree($pid)) {
    return "<ul class=\"menu\">\n". $tree ."</ul>\n";
  }
}

function mollio_menu_item($mid, $children = '', $leaf = TRUE) {
  $class = '';
  $elipses = '';
  /*
  if ($leaf) {
    $class = 'leaf';
  }
  elseif ($children) {
    $class = 'expanded';
  }
  else {
     $class = 'collapsed';
  }
  if (menu_in_active_trail($mid) || $class == 'expanded') {
    $class .= ' active';
  }
  $class = ' class="' . $class . '"';
  */

  if ($children || strstr(menu_item_link($mid), 'class="active"') !== FALSE) {
    $class = ' class="active"';
  }

  if (!$leaf) {
    $elipses = '...';
  }

  return '<li' . $class. '>'. str_replace('</a>', "$elipses</a>", menu_item_link($mid)) . $children . "</li>\n";
}

function mollio_menu_item_link($item, $link_item) {
  $attrs = array();
  if (isset($item['description'])) {
    $attrs = array('title' => $item['description']);
  }
  return l($item['title'], $link_item['path'], $attrs);
}

// custom pager output
function mollio_pager($tags = array(), $limit = 10, $element = 0, $attributes = array()) {
  global $pager_total;
  $output = '';

  if ($pager_total[$element] > 1) {
    $output .= '<div class="pagination">'; // id="pager" class="container-inline"
    $output .= '<p>';
    //$output .= theme('pager_first', ($tags[0] ? $tags[0] : t('first page')), $limit, $element, $attributes);
    $output .= theme('pager_previous', ($tags[1] ? $tags[1] : t('previous page')), $limit, $element, 1, $attributes);
    $output .= theme('pager_list', $limit, $element, ($tags[2] ? $tags[2] : 9 ), '', $attributes);
    $output .= theme('pager_next', ($tags[3] ? $tags[3] : t('next page')), $limit, $element, 1, $attributes);
    //$output .= theme('pager_last', ($tags[4] ? $tags[4] : t('last page')), $limit, $element, $attributes);
    $output .= '</p>';

    // apparently theme_pager_detail no longer exists in Drupal 4.7
    //$output .= theme('pager_detail', $limit, $element);
    $output .= '<h4>';
    $current = intval($pager_from_array[$element]);
    $current_page = floor($current / $limit) + 1;
    $total_pages = ceil($pager_total[$element] / $limit);
    $output .= sprintf('%d of %d', $current_page, $total_pages);
    $output .= '</h4>';

    $output .= '</div>';

    return $output;
  }
}

/*
function mollio_pager_detail($limit, $element = 0, $format = '%d of %d') {
  global $pager_from_array, $pager_total;
  $output = '<h4>';
  $current = intval($pager_from_array[$element]);
  $current_page = floor($current / $limit) + 1;
  $total_pages = ceil($pager_total[$element] / $limit);
  $output .= sprintf($format, $current_page, $total_pages);
  $output .= '</h4>';
  return $output;
}
*/

function mollio_pager_first($text, $limit, $element = 0, $attributes = array()) {
  global $pager_from_array;
  $output = '';
  if ($pager_from_array[$element]) {
    if ($text == 'previous page') {
      $text = '<strong>' . t('Previous') . '</strong>';
    }
    $output .= '<a href="'. pager_link(pager_load_array(0, $element, $pager_from_array), $element, $attributes) .'">'. $text .'</a>';
  }
  else {
    $output .= ' ';
  }
  return $output;
}

function mollio_pager_last($text, $limit, $element = 0, $attributes = array()) {
  global $pager_from_array, $pager_total;
  $output = '';
  $last_num = (($pager_total[$element] % $limit) ? ($pager_total[$element] % $limit) : $limit);
  $from_new = pager_load_array(($pager_total[$element] - $last_num), $element, $pager_from_array);
  if ($from_new[$element] < ($pager_from_array[$element] + $limit)) {
    $output .= theme('pager_next', $text, $limit, $element, 1, $attributes);
  }
  else if (($from_new[$element] > $pager_from_array[$element]) && ($from_new[$element] > 0) && ($from_new[$element] < $pager_total[$element])) {
    if ($text == 'next page') {
      $text = '<strong>' . t('Next') . '</strong>';
    }
    $output .= '<a href="'. pager_link($from_new, $element, $attributes) .'">'. $text .'</a>';
  }
  else {
    $output .= ' ';
  }
  return $output;
}

function mollio_pager_list($limit, $element = 0, $quantity = 5, $text = '', $attributes = array()) {
  global $pager_from_array, $pager_total;
  $output = '';
  // Calculate various markers within this pager piece:
  // Middle is used to "center" pages around the current page.
  $pager_middle = ceil((int)$quantity / 2);
  // offset adds "offset" second page
  $pager_offset = (int)$pager_from_array[$element] % (int)$limit;
  // current is the page we are currently paged to
  if (($pager_current = (ceil(($pager_from_array[$element] + 1) / $limit))) < 1) {
    $pager_current = 1;
  }
  // first is the first page listed by this pager piece (re quantity)
  $pager_first = (int)$pager_current - (int)$pager_middle + 1;
  // last is the last page listed by this pager piece (re quantity)
  $pager_last = (int)$pager_current + (int)$quantity - (int)$pager_middle;
  // max is the maximum number of pages content can is divided into
  if (!$pager_max = (ceil($pager_total[$element] / $limit))) {
    $pager_max = 1;
  }
  if ((int)$pager_offset) {
    // adjust for offset second page
    $pager_max++;
    $pager_current++;
  }
  // End of marker calculations.

  // Prepare for generation loop.
  $i = (int)$pager_first;
  if ($pager_last > $pager_max) {
    // Adjust "center" if at end of query.
    $i = $i + (int)($pager_max - $pager_last);
    $pager_last = $pager_max;
  }
  if ($i <= 0) {
    // Adjust "center" if at start of query.
    $pager_last = $pager_last + (1 - $i);
    $i = 1;
  }
  // End of generation loop preparation.

  // When there is more than one page, create the pager list.
  if ($i != $pager_max) {
    $output .= $text;
    if ($i > 1) {
      $output .= '...';
    }

    // Now generate the actual pager piece.
    for (; $i <= $pager_last && $i <= $pager_max; $i++) {
      if ($i < $pager_current) {
        $output .= theme('pager_previous', $i, $limit, $element, ($pager_current - $i), $attributes) ." ";
      }
      if ($i == $pager_current) {
        $output .= '<strong>'. $i .'</strong> ';
      }
      if ($i > $pager_current) {
        $output .= theme('pager_next', $i, $limit, $element, ($i - $pager_current), $attributes) ." ";
      }
    }

    if ($i < $pager_max) {
      $output .= '...';
    }
  }
  return $output;
}

function mollio_pager_next($text, $limit, $element = 0, $interval = 1, $attributes = array()) {
  global $pager_from_array, $pager_total;
  $output = '';
  $from_new = pager_load_array(((int)$pager_from_array[$element] + ((int)$limit * (int)$interval)), $element, $pager_from_array);
  if ($from_new[$element] < $pager_total[$element]) {
    if ($text == 'next page') {
      $text = '<strong>' . t('Next') . '</strong>';
    }
    $output .= '<a href="'. pager_link($from_new, $element, $attributes) .'">'. $text .'</a>';
  }
  else {
    $output .= ' ';
  }
  return $output;
}

function mollio_pager_previous($text, $limit, $element = 0, $interval = 1, $attributes = array()) {
  global $pager_from_array;
  $output = '';
  $from_new = pager_load_array(((int)$pager_from_array[$element] - ((int)$limit * (int)$interval)), $element, $pager_from_array);
  if ($from_new[$element] < 1) {
    $output .= theme('pager_first', $text, $limit, $element, $attributes);
  }
  else {
    if ($text == 'previous page') {
      $text = '<strong>' . t('Previous') . '</strong>';
    }
    $output .= '<a href="'. pager_link($from_new, $element, $attributes) .'">'. $text . '</a>';
  }
  return $output;
}

// custom form elements
function mollio_form_element($title, $value, $description = NULL, $id = NULL, $required = FALSE, $error = FALSE) {
  $allowed_tags = '<label><input><submit><button><select><option><textarea><fieldset><legend><dl><dd><dt><ul><li><a><em><strong><i><b><table><caption><thead><tbody><tfoot><tr><th><td>';
  $required = $required ? '<span class="req">*</span>' : '';

  /*
  Mollio form markup...
  <label for="firstname"><b><span class="req">*</span>First name:</b>
  <input id="firstname" name="firstname" type="text" class="f-name" tabindex="1" /><br />
  </label>
  */

  if ($title) {
    if ($id) {
      $output .= " <label for=\"$id\"><b>$required$title:</b></label>\n"; //</label>\n
    }
    else {
      $output .= " <label><b>$required$title:</b></label>\n"; //</label>\n
    }
  }

  //$output .= strip_tags($value, $allowed_tags);
  //$value = str_replace('<label>', '', $value);
  //$value = str_replace('</label>', '', $value);
  $output .= $value;
  $output .= "<br />\n";

  /*
  if ($title) {
    $output .= '</label>';
  }
  */

  if ($description) {
    $output .= "<div class=\"description\">$description</div>\n";
  }

  return $output;
}

// custom search results
function mollio_search_item($item, $type) {
  $output = '';
/*
<li>
  <dl>
    <dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>
    <dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>
    <dd class="filetype">HTML</dd>
    <dd class="date">22 April 2005</dd>
  </dl>
</li>
*/

  if (module_hook($type, 'search_item')) {
    $output = module_invoke($type, 'search_item', $item);
  }
  else {
    $output .= '<dd>' . "\n";
    $output .= '  <dl>' . "\n";
    $output .= '    <dt class="title"><a href="'. check_url($item['link']) .'">'. check_plain($item['title']) .'</a></dt>' . "\n";
    $output .= '    <dd class="desc">' . $item['snippet'] . '</dd>' . "\n";
    if ($item['type']) {
      $output .= '    <dd class="filetype">' . $item['type'] . '</dd>' . "\n";
    }
    if ($item['date']) {
      $output .= '    <dd class="date">' . format_date($item['date'], 'small') . '</dd>' . "\n";
    }

    $info = array();
    if ($item['user']) {
      $info[] = $item['user'];
    }
    if (is_array($item['extra'])) {
      $info = array_merge($info, $item['extra']);
    }
    $output .= '    <dd>'. implode(' - ', $info) .'</dd>' . "\n";
    $output .= '  </dl>' . "\n";
    $output .= '</dd>' . "\n";
  }

  return $output;
}

?>